package com.example.demo;

import java.util.List;
import java.util.HashMap;

import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api/categories")
public class ApiController {
    HashMap<Integer, Category> categories = new HashMap<>();

    @GetMapping
    public List<Category> getCategories() {
        return List.copyOf(categories.values());
    }

    @GetMapping("/{id}")
    public Category getCategory(@PathVariable(name = "id") Integer id) {
        return categories.get(id);
    }

    @PostMapping
    public Category postCategory(@RequestBody Category category) {
        categories.put(categories.size() + 1, category);
        return category;
    }

    @PutMapping("/{id}")
    public Category putCategory(@PathVariable(name = "id") Integer id, @RequestBody Category entity) {
        if (!categories.containsKey(id))
            return null;
        categories.replace(id, entity);
        return categories.get(id);
    }

    @DeleteMapping("/{id}")
    public Category delCategory(@PathVariable(name = "id") Integer id) {
        return categories.remove(id);
    }
}
